hello(world).
hello(earth).
hello(mars).
male(albert).
male(edward).
female(alice).
female(victoria).
parent(albert, edward).
parent(victoria, edward).
parent(albert, alice).
parent(victoria, alice).
parent(sally, jane).
parent(bob,jane).
parent(sally, john).
parent(bob, john).
parent(mary, sally).
parent(al, sally).
parent(ann, bob).
parent(mike,bob).
parent(jean, al).
parent(joe, al).
parent(ruth, mary).
parent(jim, mary).
parent(esther, ruth).
parent(mick, ruth).
sibling(X, Y) :- parent(Z, X), parent(Z, Y).
grandparent(X, Y) :- parent(Z, Y), parent(X, Z).
basket([apple, prune, grape, kumquat]).
basket([lobster, clam, scallop]).
head_basket(Head) :- basket([Head | Tail]).
app([],List,List).
app([Head | Tail], Second, [Head | Result]) :- app(Tail, Second, Result).
rev([], []).
rev([Head | Tail], RevList) :- rev(Tail, Result), append(Result, [Head], RevList).
mem(X, X).
mem(X, [Head | Tail]) :- mem(X, Head).
mem(X, [Head | Tail]) :- mem(X, Tail).
intersect(X, List1, List2) :- mem(X, List1), mem(X, List2).
union(X, List1, List2) :- mem(X,List1).
union(X, List1, List2) :- mem(X,List2).
human(bart).
human(lisa).
human(maggie).
human(marge).
food(donut).
food(bart).
meal(X) :- \+human(X), food(X).
